Stone Game

[leetcode]Stone Game

链接:https://leetcode.com/problems/stone-game/description/

Question

Alex and Lee play a game with piles of stones. There are an even number of piles arranged in a row, and each pile has a positive integer number of stones piles[i].

The objective of the game is to end with the most stones. The total number of stones is odd, so there are no ties.

Alex and Lee take turns, with Alex starting first. Each turn, a player takes the entire pile of stones from either the beginning or the end of the row. This continues until there are no more piles left, at which point the person with the most stones wins.

Assuming Alex and Lee play optimally, return True if and only if Alex wins the game.

Example 1

Input: [5,3,4,5]
Output: true
Explanation: 
Alex starts first, and can only take the first 5 or the last 5.
Say he takes the first 5, so that the row becomes [3, 4, 5].
If Lee takes 3, then the board is [4, 5], and Alex takes 5 to win with 10 points.
If Lee takes the last 5, then the board is [3, 4], and Alex takes 4 to win with 9 points.
This demonstrated that taking the first 5 was a winning move for Alex, so we return true.

Note:
2 <= piles.length <= 500
piles.length is even.
1 <= piles[i] <= 500
sum(piles) is odd.

Solution

// https://leetcode.com/problems/stone-game/description/
// 题意:Alex是否能从偶数堆里面获胜,其实从intuition就知道肯定是可以的,因为最后Alex和对手肯定是各自有一堆,那想象成Alex拿到了其中大的那堆就可以了
class Solution {
public:
  bool stoneGame(vector<int>& piles) {
    int size = piles.size();
    // dp[i][j]的含义是在i到j堆中,Alex比对手多了多少石子
    vector<vector<int> > dp;
    dp.resize(size, vector<int>());
    for (int i = 0; i < size; i++) dp[i].resize(size, 0);
    for (int i = 0; i < size; i++) dp[i][i] = -piles[i];

    for (int i = 0; i < size; i++) {
      for (int j = i+1; j < size; j++) {
        // 通过剩余石子数可以判断是Alex局还是对手局
        if ((j-i) % 2 == 1) {
          // Alex希望dp越大越好
          dp[i][j] = max(dp[i+1][j]+piles[i], dp[i][j-1]+piles[j]);
        } else {
          // 对手希望dp越小越好
          dp[i][j] = min(dp[i+1][j]-piles[i], dp[i][j-1]-piles[j]);
        }
      }
    }
    // 如果最终大于0,则说明Alex获胜
    return dp[0][size-1] > 0;
  }
};

int main(int argc, char const *argv[]) {
  vector<int> piles = {5, 3, 4, 5};
  Solution s;
  cout << s.stoneGame(piles) << endl;
  return 0;
}

思路:这是一道博弈题,可以使用动归完成。类似于Predict the Winner,状态转移方程也类似。

你可能感兴趣的:(leetcode,动态规划,博弈论)